//-----------------------------------------------------------------------------
//
//  Mail file converter         == SOLID-C compiler test example ==
//
//-----------------------------------------------------------------------------
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
//#include <dos.h>

void perror();
struct FIND {
  char *name;
  };
struct FIND *findfirst();
struct FIND *findnext();
char *memset();

#pragma optimize time
#pragma nonrec
#define EXIT_FAILURE (-1)
#define EXIT_SUCCESS ( 1)


void skip_to_header();
void rework_file();

FILE *invoer,*uitvoer;
char in_naam[65],uit_naam[65];
//-----------------------------------------------------------------------------
void main(argc, argv)
  int argc;
  char *argv[];
{
    struct FIND *entry;
    int lengte;

    entry=findfirst("*.mbx",0);
    while (entry!=NULL)
    {
        memset(uit_naam,0,65);
        strcpy(in_naam,entry->name);
        lengte=strlen(in_naam);
        strncpy(uit_naam,in_naam,lengte-3);
        strcat(uit_naam,"txt");
        rework_file();
        entry=findnext();
    }
    printf("\nAll Files Processed\n");
    exit(EXIT_SUCCESS);
}
//-----------------------------------------------------------------------------
void rework_file()
{
    int karakter,msg_count;

    if ((invoer=fopen(in_naam,"rb"))==NULL)
    {
        printf("%s\n",in_naam);
        perror("Could not open input file %s");
        exit(EXIT_FAILURE);
    }
    if ((uitvoer=fopen(uit_naam,"wb"))==NULL)
    {
        perror("Could not open output file");
        exit(EXIT_FAILURE);
    }
    printf("\nProcessing File : %s",in_naam);
    msg_count=0;
    karakter=255;
    while((!feof(invoer))&&(karakter!=0))
        karakter=fgetc(invoer);
    if (feof(invoer))
    {
        fclose(invoer);
        fclose(uitvoer);
        printf("\n\nStart Header Not Header Found\n");
        exit(EXIT_FAILURE);
    }
    skip_to_header();
    msg_count++;
    while(!feof(invoer))
    {
        karakter=fgetc(invoer);
        if (karakter!=0)
            fputc(karakter,uitvoer);
        else
        {
            skip_to_header();
            msg_count++;
        }
    }
    fclose(invoer);
    fclose(uitvoer);
    printf(" - Messages Read : %d\n",msg_count);
}
//-----------------------------------------------------------------------------
void skip_to_header()
{
    static int karakters[64];
    int counter,sub_counter;
    int flag_zero,round;

    round=0;
    while(round<2)
    {
        for(counter=0;counter<64;counter++)
        {
            karakters[counter]=fgetc(invoer);
            if (feof(invoer))
                return;
        }
        for(counter=0;counter<59;counter++)
        {
            flag_zero=0;
            for(sub_counter=0;sub_counter<6;sub_counter++)
                if (karakters[counter+sub_counter]==0)
                    flag_zero=1;
            if (flag_zero==0)
            {
                fputs("\nFrom a@b Sun Jan 1 00:00:00 1990\n",uitvoer);
                for(sub_counter=counter;sub_counter<64;sub_counter++)
                    fputc(karakters[sub_counter],uitvoer);
                return;
            }
        }
        round++;
    }
    perror("Could Not Find Next Header");
    exit(EXIT_FAILURE);
}
//-----------------------------------------------------------------------------

